<?php
/**
 * 
 * Hanle connection to session
 * @singleton
 * @author alex
 */
class SessionManager {
	/**
	 * curent instance
	 * @var SessionManager
	 */
	private static $instance;
	
	private function __construct(){}
	
	/**
	 * Start session
	 * @return SessionManager
	 */
	public static function start()
	{
		if (!isset(self::$instance)) {
			$className = __CLASS__;
			self::$instance = new $className;
			if (!session_start()) {
				throw new Exception('Cannot start session');
			}
		}
		return self::$instance;
	}
	/**
	 * 
	 * @return SessionManager
	 */
	public static function instance() {
		return self::$instance;
	}
	/**
	 * Get value from session
	 * @param mixed $key
	 * @return mixed - null if no value found
	 */
	public function get($key) {
		return (isset($_SESSION[$key])) ? $_SESSION[$key] : null;
	}
	/**
	 * Put value to session
	 * @param string $key string
	 * @param mixed $value
	 */
	public function put($key, $value) {
		$_SESSION[$key] = $value;
	}
	/**
	 * Finish current session
	 */
	public static function destroy() {
		session_destroy();
		self::$instance = null;
	}
}