<?php
/**
 * Login page controller
 * @author alex
 *
 */
class Stock_Page_Login_Controller extends Stock_Controller {
	const PARAM_USERNAME = 'username';
	const PARAM_PASSWORD = 'password';
	
	const ADMIN_LOGIN = 'admin';
	const ADMIN_PASSSWORD = 'admin';
	
	/**
	 * @var Stock_Page_Login_View
	 */
	private $view;
	/**
	* @var Stock_Page_Login_Context
	*/	
	private $context;
	
	public function __construct() {
		$this->context = new Stock_Page_Login_Context();
		$this->view = new Stock_Page_Login_View($this->context);	
	}
		
	public function run() {
		$action = Stock_Router::getAction();
		if ($action == Stock_Router::ACT_LOGIN_PROCESS) {
			$pass = (!empty($_POST[self::PARAM_PASSWORD])) ? trim($_POST[self::PARAM_PASSWORD]) : '';
			$uname = (!empty($_POST[self::PARAM_USERNAME])) ? trim($_POST[self::PARAM_USERNAME]) : '';

			if ($uname == self::ADMIN_LOGIN && $pass == self::ADMIN_PASSSWORD) {
				SessionManager::instance()->put(self::KEY_ADMIN, true);
				Stock_Router::redirect(Stock_Router::ACT_ADMIN_OVERVIEW);
				return;
			}
			
			$user = Stock_User_Login::auth($uname, $pass);
			if ($user) {
				SessionManager::instance()->put(self::KEY_USER, $user);
				Stock_Router::redirect(Stock_Router::ACT_USER_SELECTDATES);
				return;
			} else {
				$this->context->setUserNotFound(true);
			}
		}
		if ($action == Stock_Router::ACT_LOGOUT) {
			SessionManager::destroy();
			Stock_Router::redirect(Stock_Router::ACT_LOGIN_FORM);
			return;
		}
		$this->view->show();
	}
	
}
