<?php
/**
 * Registration page controller
 * @author alex
 *
 */
class Stock_Page_Register_Controller extends Stock_Controller {
	const PARAM_USERNAME = 'username';
	const PARAM_PASSWORD = 'password';
	
	const INITIAL_BALANCE = 10000;
	/**
	 * @var Stock_Page_Register_View
	 */
	private $view;
	/**
	* @var Stock_Page_Register_Context
	*/	
	private $context;
	
	public function __construct() {
		$this->context = new Stock_Page_Register_Context();
		$this->view = new Stock_Page_Register_View($this->context);
	}
		
	public function run() {
		$action = Stock_Router::getAction();
		if ($action == Stock_Router::ACT_REGISTER_PROCESS) {
			$pass = (!empty($_POST[self::PARAM_PASSWORD])) ? trim($_POST[self::PARAM_PASSWORD]) : '';
			$uname = (!empty($_POST[self::PARAM_USERNAME])) ? trim($_POST[self::PARAM_USERNAME]) : '';

			$storage = new Stock_User_Storage();
			if ($uname && $pass) {
				if ($storage->load($uname)) {
					$this->context->setFormMessage("User already exist");
				} else {
					$user = new Stock_User(0, $uname, self::INITIAL_BALANCE);
					$user_id = $storage->save($user, $pass);
					// created successfully  -> redirect to portfoli page
					if ($user_id > 0) {
						$user->setId($user_id);
						SessionManager::instance()->put(self::KEY_USER, $user);
						Stock_Router::redirect(Stock_Router::ACT_USER_SELECTDATES);
						return;
					}
				}
			} else {
				$this->context->setFormMessage('Username or passowrd cannot be empty');
			}
		}
		$this->view->show();
	}
	
}
