<?php
/**
 * Basic controller for user loged-in pages
 * @author alex
 *
 */
abstract class Stock_Page_User_Controller extends Stock_Controller {
	/**
	 * @var Stock_User
	 */
	protected $user;
	/**
	 * @var string 'Y-m-d'
	 */
	protected $todayDate; 
	/* (non-PHPdoc)
	 * @see Stock_Controller::run()
	 */
	public function run() {
		if (!$this->validateUser()) {
			Stock_Router::redirect(Stock_Router::ACT_LOGOUT);
			return;			
		}
		if (!$this->validateDate()) {
			Stock_Router::redirect(Stock_Router::ACT_LOGOUT);
			return;			
		}		
		$this->runUser();
	}

	abstract protected function runUser();
	
	protected function validateUser() {
		$this->user = SessionManager::instance()->get(self::KEY_USER);
		if (!$this->user) {
			return false; 
		}
		return true;
	}
	protected function validateDate() {
		$this->todayDate = SessionManager::instance()->get(self::KEY_TODAY_DATE);
		if (!$this->todayDate) {
			return false; 
		}
		return true;
	}	
}

?>