<?php
/**
 * Display all history deals by user
 * @author alex
 *
 */
class Stock_Page_User_History_Controller extends Stock_Page_User_Controller {
	const PARAM_SYMBOL = 'symbol';
	/**
	 * @var Stock_Page_User_History_View
	 */
	private $view;
	/**
	* @var Stock_Page_User_History_Context
	*/	
	private $context;
	
	public function __construct() {
		$this->context = new Stock_Page_User_History_Context();
		$this->view = new Stock_Page_User_History_View($this->context);
	}
	
	protected function runUser() {
		$action = Stock_Router::getAction();
		$this->context->setUser($this->user);
		$this->context->setTodayDate($this->todayDate);
		
		$quotes = $this->buildUserQuotesInfo();
		$this->context->setQuotes($quotes);
		$this->view->show();
	}
	
	protected function buildUserQuotesInfo() {
		$storage = new Stock_User_Quote_Storage();
		$purchasedQuotes = $storage->loadPurchased($this->user->getId());
		
		$soldQuotes = $storage->loadSold($this->user->getId());

		$quotes = array_merge($purchasedQuotes, $soldQuotes);
		usort($quotes, array($this,'compareTimestamp'));
		
		return $quotes;
	}
	
	protected function compareTimestamp(Stock_User_Quote $a, Stock_User_Quote $b) {
		if ($a->getTimestamp() == $b->getTimestamp()) {
			return 0;
		}
		return ($a->getTimestamp() < $b->getTimestamp()) ? 1 : -1;
	}
}

