<?php
class Stock_Page_User_History_View extends Stock_Page_User_View {
	
	protected function title() {
		return 'History';
	}
	
	protected function user() {
		return $this->context->getUser()->getName();
	}	
	
	protected function content() {
		/* @var $context Stock_Page_User_History_Context */
		$context = $this->context;
		?>
		Your balance on <?=strftime("%b %d, %Y", strtotime($context->getTodayDate()))?> is: $<?=number_format($context->getUser()->getBalance(),2)?>
		<br/><br/>
		<?
		$quotes = $context->getQuotes();
		if (!$quotes) {
		?>
			Currently you don't have any quote.
		<? 
		} else {
		?>
			<table class="historyquotes">
				<tr>
					<th>Time</th>
					<th>Action</th>
					<th>Symbol</th>
					<th>Quantity</th>
					<th>Price paid</th>
				</tr>
 			<?  /* @var $quote Stock_User_Quote */
 				foreach ($quotes AS $quote) {?>
 				<tr>
					<td><?=strftime("%b %d %Y %H:%M:%S", $quote->getTimestamp())?></td>
					<td><?=($quote instanceof Stock_User_Quote_Sold) ? 'Sell' : 'Buy'?></td>
					<td><?=$quote->getSymbol()?></td>
					<td><?=$quote->getQuantity()?></td>
					<td>$<?=number_format($quote->getPricePaid(),2)?></td>
				</tr>
 			<? } ?>
			</table>
		<?
		}
	}

}