<?php
/**
 * Display user portfolio
 * @author alex
 *
 */
class Stock_Page_User_Portfolio_Controller extends Stock_Page_User_Controller {
	const PARAM_SYMBOL = 'symbol';
	/**
	 * @var Stock_Page_User_Portfolio_View
	 */
	private $view;
	/**
	* @var Stock_Page_User_Portfolio_Context
	*/	
	private $context;
	
	public function __construct() {
		$this->context = new Stock_Page_User_Portfolio_Context();
		$this->view = new Stock_Page_User_Portfolio_View($this->context);
	}
	
	protected function runUser() {
		$action = Stock_Router::getAction();
		$this->context->setUser($this->user);
		$this->context->setTodayDate($this->todayDate);
		
		if ($action == Stock_Router::ACT_USER_SEARCH_QUOTE) {
			$symbol = (isset($_POST[self::PARAM_SYMBOL])) ? $_POST[self::PARAM_SYMBOL] : '';
			$symbol = strtoupper($symbol);
			$result = $this->searchQuotes($symbol);
			$this->context->setSearchResults($result);
			$this->context->setSearchRequest($symbol);
		}
		
		$helper = new Stock_User_Quote_Helper();
		$quotes = $helper->buildQuotesInfo($this->todayDate, $this->user);
		$this->context->setQuotes($quotes);
		$this->view->show();
	}
	
	protected function searchQuotes($symbol) {
		$symbol = trim($symbol);
		if (!$symbol) {
			return array();
		}
		$storage = new Stock_Quote_Storage();
		return $storage->search($this->todayDate, $symbol);
	}
	
}

