<?php
class Stock_Page_User_Portfolio_View extends Stock_Page_User_View {
	
	protected function title() {
		return 'Portfolio';
	}
	
	protected function user() {
		return $this->context->getUser()->getName();
	}	
	
	protected function content() {
		/* @var $context Stock_Page_User_Portfolio_Context */
		$context = $this->context;
		$request = $context->getSearchRequest();
		?>
		<h2>Search</h2>
		<form action="<?=$context->createUrl(Stock_Router::ACT_USER_SEARCH_QUOTE)?>" method="post">
			<label for="symbol">Enter symbol:</label>
			<input type="text" name="<?=Stock_Page_User_Portfolio_Controller::PARAM_SYMBOL?>" value="<?=$request?>" />
			<input type="submit" value="Search" />
		</form>
		<? if ($request) { ?>
			<h2>Result for '<?=$context->getSearchRequest()?>'</h2>
			<?
			$results = $context->getSearchResults();
			if (!$results) {
			?>
				No quotes found for symbol.
			<? 
			} else {
			?>
				<table class="stockquotes">
					<tr>
						<th>Action</th>
						<th>Symbol</th>
						<th>Price</th>
						<th>Volume</th>
					</tr>
	 			<? 	/* @var $stockQuote Stock_Quote */
	 				foreach ($results AS $stockQuote) {?>
	 				<tr>
						<td><a href="<?=$context->createUrl(
							Stock_Router::ACT_USER_BUY, 
							array(
								Stock_Page_User_Trade_Controller::PARAM_SYMBOL => $stockQuote->getSymbol()
							)
						)?>">Buy</a></td>
						<td><?=$this->renderSymbol($stockQuote->getSymbol())?></td>
						<td>$<?=number_format($stockQuote->getPriceClose(),2)?></td>
						<td><?=$stockQuote->getVolume()?></td>
					</tr>
	 			<? } ?>
				</table>
			
			<? } ?>
		<? } ?>
		<h2>My quotes</h2>
		Your balance on <?=strftime("%b %d, %Y", strtotime($context->getTodayDate()))?> is: $<?=number_format($context->getUser()->getBalance(),2)?>
		<br/><br/>
		<?
		$quotes = $context->getQuotes();
		if (!$quotes) {
		?>
			Currently you don't have any quote.
		<? 
		} else {
		?>
			<table class="myquotes">
				<tr>
					<th>Action</th>
					<th>Symbol</th>
					<th>Price paid</th>
					<th>Quantity</th>
					<th>Last price</th>
					<th>Change</th>
					<th>MKT price</th>
					<th>Profit</th>
					<th>%</th>
				</tr>
 			<?  /* @var $quote Stock_User_Quote_DayInfo */ 
 			   	foreach ($quotes AS $quote) { ?>
 				<tr>
					<td><a href="<?=$context->createUrl(
						Stock_Router::ACT_USER_BUY, 
						array(
							Stock_Page_User_Trade_Controller::PARAM_SYMBOL => $quote->getSymbol()
						)
					)?>">Buy</a> / <a href="<?=$context->createUrl(
						Stock_Router::ACT_USER_SELL, 
						array(
							Stock_Page_User_Trade_Controller::PARAM_SYMBOL => $quote->getSymbol()
						)
					)?>">Sell</a></td>
					<td><?=$this->renderSymbol($quote->getSymbol())?></td>
					<td>$<?=number_format($quote->getPriceAvg(),2)?></td>
					<td><?=$quote->getQuantity()?></td>
					<td>$<?=number_format($quote->getLastPrice(),2)?></td>
					<td>$<?=number_format($quote->getChange(),2)?></td>
					<td>$<?=number_format($quote->getMktPrice(),2)?></td>
					<td>$<?=number_format($quote->getProfit(),2)?></td>
					<td><?=number_format($quote->getPercent(),2)?>%</td>
				</tr>
 			<? } ?>
			</table>
		<?
			$this->printUserChart();				
		}
	}

	private function renderSymbol($symbol) {
		$url = $this->context->createUrl(
			Stock_Router::ACT_USER_SYMBOL, 
			array(Stock_Page_User_Symbol_Controller::PARAM_SYMBOL => $symbol)
		);
		return '<a href="'.$url.'">'.$symbol.'</a>';
	}
	
	private function printUserChart() {
		?>
		<h2>Overview</h2>
		<div id="userchart" style="height:400px;width:700px; "></div>
		<script type="text/javascript"> 
		$(function () {
		    var options = {
				legend: { show: true, position: "nw" },
		        lines: { show: true },
		        points: { show: true },
		        xaxis: {
		           mode: "time",
		           timeformat: "%y/%m/%d"
		        }
		    };
		    var placeholder = $("#userchart");
		    
		    $.plot(placeholder, [], options);
			var dataurl = "<?=$this->context->createUrl(Stock_Router::ACT_USER_JSON_QUOTES)?>";
			// then fetch the data with jQuery
			function onUserDataReceived(data) {
				// and plot all we got
				$.plot(placeholder, data, options);
			}
			$.ajax({
				url: dataurl,
				method: 'GET',
				dataType: 'json',
				success: onUserDataReceived
			});
		});
		</script> 		
		<?	
	}
}