<?php
class Stock_Page_User_Symbol_View extends Stock_Page_User_View {
	
	protected function title() {
		return 'Symbol Information';
	}
	
	protected function user() {
		return $this->context->getUser()->getName();
	}	
	
	protected function content() {
		/* @var $context Stock_Page_User_Symbol_Context */
		$context = $this->context;
		$symbol = $this->context->getSymbol();
		?>
		<h3>Quote for <?=$symbol?></h3>
		<div id="userchart" style="height:400px;width:700px; "></div>
		<script type="text/javascript"> 
		$(function () {
		    var options = {
				legend: { show: true, position: "nw" },
		        lines: { show: true },
		        points: { show: true },
		        xaxis: {
		           mode: "time",
		           timeformat: "%y/%m/%d"
		        }
		    };
		    var placeholder = $("#userchart");
		    
		    $.plot(placeholder, [], options);
			var dataurl = "<?=$this->context->createUrl(
				Stock_Router::ACT_USER_JSON_SYMBOL,
				array(Stock_Page_User_Quotes_Controller::PARAM_SYMBOL => $symbol)
			)?>";
			// then fetch the data with jQuery
			function onUserDataReceived(data) {
				// and plot all we got
				$.plot(placeholder, data, options);
			}
			$.ajax({
				url: dataurl,
				method: 'GET',
				dataType: 'json',
				success: onUserDataReceived
			});
		});
		</script> 		
		<br/>
		<a href="<?=$context->createUrl(Stock_Router::ACT_USER_PORFOLIO)?>">&larr; Back to portfolio</a>
		<?
	}

}