<?php
class Stock_Page_User_Trade_View extends Stock_Page_User_View {
	
	protected function title() {
		return 'Portfolio';
	}
	
	protected function user() {
		return $this->context->getUser()->getName();
	}	
	
	protected function content() {
		/* @var $context Stock_Page_User_Trade_Context */
		$context = $this->context;
		$typeText = ($context->getType() == Stock_Page_User_Trade_Context::TYPE_SELL) ?
			'Sell' : 'Buy' 
		;
		$action = ($context->getType() == Stock_Page_User_Trade_Context::TYPE_SELL) ?
			$context->createUrl(Stock_Router::ACT_USER_SELL_CONFIRM) :
			$context->createUrl(Stock_Router::ACT_USER_BUY_CONFIRM)
		;
		$quantityValue = ($context->getQuantity() > 0) ? $context->getQuantity() : '';
		?>
		<h2>Confirm transaction</h2>
		Your balance is: $<?=number_format($context->getUser()->getBalance(),2)?>
		<br/><br/>
		<h3><?=$typeText?></h3>
		<? if ($context->getErrorMsg()) {?>
			<div class="error-message"><?=$context->getErrorMsg()?></div>
		<? } ?>
		<form action="<?=$action?>" method="post">
			<input type="hidden" name="<?=Stock_Page_User_Trade_Controller::PARAM_SYMBOL?>" value="<?=$context->getQuote()->getSymbol()?>">
			<div class="form-element">
				<div class="label">Symbol:</div>
				<div class="value"><strong><?=$context->getQuote()->getSymbol()?></strong></div>
			</div>
			<div class="form-element">
				<div class="label">Quantity:</div>
				<div class="value">
					<input id="quantity" type="text" name="<?=Stock_Page_User_Trade_Controller::PARAM_QUANTITY?>" value="<?=$quantityValue?>" class="input-qunatity">
					<? if ($context->getType() == Stock_Page_User_Trade_Context::TYPE_SELL) { ?>
						( Up to <?=$context->getMaxQuantity()?> )
					<? } ?>
				</div>
			</div>
			<div class="form-element">
				<div class="label">Price:</div>
				<div class="value"><strong>$<?=$context->getQuote()->getPriceClose()?></strong></div>
			</div>
			<div class="form-element">
				<div class="label">Total:</div>
				<div class="value">$<span id="totalSum">0.00</span></div>
			</div>
			<div class="form-element">
				<div class="label">Commission (1%)</div>
				<div class="value">$<span id="commSum">0.00</span></div>
			</div>
			<div class="form-element">
				<div class="label">Total + Comission:</div>
				<div class="value">$<span id="totalCommSum">0.00</span></div>
			</div>
			<div class="form-element">
				<div class="label">&nbsp;</div>
				<div class="value"><input type="submit" value="Confirm" /></div>
			</div>			
			
		</form>
		<script type="text/javascript">
			var quotePrice = '<?=$context->getQuote()->getPriceClose()?>';
			$("#quantity").keyup(function() {
				var q=(this.value) ? parseInt('0'+this.value,10) : 0;
				var total = parseFloat(quotePrice) * q;
				var comm = (1*total) / 100;
				var cTotal = total + comm
				$("#totalSum").html(total.toFixed(2));
				$("#commSum").html(comm.toFixed(2));
				$("#totalCommSum").html(cTotal.toFixed(2));
			});
		</script>		
		<br/>
		<a href="<?=$context->createUrl(Stock_Router::ACT_USER_PORFOLIO)?>">&larr; Back to portfolio</a>
		<?
	}

}