<?php
/**
 * Save and Load user quotes information
 * @author alex
 *
 */
class Stock_User_Quote_Storage {
	const SQL_LOAD_PURCHASED = "
		SELECT user_id,`date`,symbol,price,quantity,`timestamp` 
		FROM quotes_purchased 
		WHERE quantity > 0
	";
	const SQL_LOAD_SOLD = "
		SELECT user_id,`date`,symbol,price,quantity,`timestamp`
		FROM quotes_sold 
	";
	const SQL_SAVE_PURCHASED = "
		REPLACE INTO quotes_purchased (user_id,`date`,symbol,price,quantity,`timestamp`)
		VALUES ('%s','%s','%s','%s','%s','%s')
	";
	const SQL_SAVE_SOLD = "
		INSERT INTO quotes_sold (user_id,`date`,symbol,price,quantity,`timestamp`)
		VALUES ('%s','%s','%s','%s','%s','%s')
	";
	
	/**
	 * Load last purchase by user
	 * @param int $userId
	 * @return Stock_User_Quote
	 */
	public function loadLastPurchase($userId) {
		$sql = self::SQL_LOAD_PURCHASED;
		$sql.=sprintf(" AND user_id = '".(int)$userId."'");
		$sql.=" ORDER BY `timestamp` DESC LIMIT 1";
		$result = Db::acquire()->query($sql);
		if (!$result) {
			return null;
		}
		$row = mysql_fetch_assoc($result);
		if (!$row) {
			return null;
		}
		return $this->createQuote($row);
	}
	
	/**
	 * Load all purchased quotes
	 * @param int $userId
	 * @return array Stock_User_Quote
	 */
	public function loadPurchased($userId = 0, $symbol = '') {
		$sql = self::SQL_LOAD_PURCHASED;
		if ($userId > 0) {
			$sql.=sprintf(" AND user_id = '".(int)$userId."'");	
		}
		if ($symbol) {
			$sql.=sprintf(" AND symbol = '%s'",mysql_real_escape_string($symbol));
		}
		$result = Db::acquire()->read($sql);
		if (!$result) {
			return array();
		}
		$quotes = array();
		foreach($result AS $row) {
			$quotes[] = $this->createQuote($row);
		}
		return $quotes;
	}
	
	/**
	 * @param int $userId
	 * @return Stock_User_Quote
	 */	
	public function loadLastSell($userId) {
		$sql = self::SQL_LOAD_SOLD;
		$sql.=sprintf(" WHERE user_id = '".(int)$userId."'");
		$sql.=" ORDER BY `timestamp` DESC LIMIT 1";
		$result = Db::acquire()->query($sql);
		if (!$result) {
			return null;
		}
		$row = mysql_fetch_assoc($result);
		if (!$row) {
			return null;
		}
		return $this->createQuote($row);
	}
	/**
	 * Load all sold quotes
	 * @param int $userId
	 * @return array Stock_User_Quote
	 */
	public function loadSold($userId = 0) {
		$sql = self::SQL_LOAD_SOLD;
		if ($userId > 0) {
			$sql.=sprintf(" WHERE user_id = '".(int)$userId."'");	
		}
		$result = Db::acquire()->read($sql);
		if (!$result) {
			return array();
		}
		$quotes = array();
		foreach($result AS $row) {
			$quotes[] = $this->createSoldQuote($row);
		}
		return $quotes;
	}	
	
	/**
	 * Saves new purchased quote
	 * @param Stock_User_Quote $quote
	 * @return bool 
	 */	
	public function savePurchased(Stock_User_Quote $quote) {
		$sql = sprintf(self::SQL_SAVE_PURCHASED,
			$quote->getUserId(),
			mysql_real_escape_string($quote->getDate()),
			mysql_real_escape_string($quote->getSymbol()),
			$quote->getPricePaid(),
			$quote->getQuantity(),
			date("Y-m-d H:i:s",$quote->getTimestamp())
		);
		return Db::acquire()->query($sql);
	}
	
	/**
	 * Save sold quote
	 * @param Stock_User_Quote $quote
	 */	
	public function saveSold(Stock_User_Quote $quote) {
		$sql = sprintf(self::SQL_SAVE_SOLD,
			$quote->getUserId(),
			mysql_real_escape_string($quote->getDate()),
			mysql_real_escape_string($quote->getSymbol()),
			$quote->getPricePaid(),
			$quote->getQuantity(),
			date("Y-m-d H:i:s",$quote->getTimestamp())
		);
		return Db::acquire()->query($sql);
	}
		
	/**
	 * Create quote object from db row
	 * @param array $row
	 * @return array Stock_User_Quote
	 */
	protected function createQuote(array $row) {
		return new Stock_User_Quote(
			$row['user_id'],
			$row['date'],
			$row['symbol'],
			$row['price'],
			$row['quantity'],
			strtotime($row['timestamp'])
		);
	}

	/**
	 * @param array $row
	 * @return array Stock_User_Quote_Sold
	 */
	protected function createSoldQuote(array $row) {
		return new Stock_User_Quote_Sold(
			$row['user_id'],
			$row['date'],
			$row['symbol'],
			$row['price'],
			$row['quantity'],
			strtotime($row['timestamp'])
		);
	}	
}

?>