<?php
/**
 * View of Webservice API Information page
 * @author alex
 *
 */
class Stock_Page_Webservice_View extends Stock_View {
	
	protected function title() {
		return 'Webservice API';
	}
	
	protected function content() {
		/* @var $context Stock_Page_Login_Context */
		$context = $this->context;
		?>
		<h2>Overview</h2>
		<h3>Request</h3>
		Send request using REST GET method <br/>
		<h4>Common required fields:</h4>
		<ul>
			<li><?=Stock_Webservice_Controller::PARAM_USERNAME?></li>
			<li><?=Stock_Webservice_Controller::PARAM_PASSWORD?></li>
			<li><?=Stock_Webservice_Controller::PARAM_DATE?></li>
		</ul>
		<h3>Response</h3>
		Response formated as XML.<br/>
		Root tag is <strong>&lt;response&gt;</strong><br/>
		In case of error response will incliude tag: <strong>&lt;error code="code"&gt;Message&lt;error&gt;</strong><br/>
		Code attribute - code of error<br/>
		Message - message of error<br/>
		<h4>Common error codes:</h4>
		<ul>
			<li><strong><?=Stock_Webservice_Controller::ERROR_CODE_AUTH?></strong> - Authentification error</li>
			<li><strong><?=Stock_Webservice_Controller::ERROR_CODE_DATE?></strong> - Date error</li>
		</ul>
		<h4>Error response example</h4>
		<p>
			<span class="xv-tag-open" style="color: rgb(95, 175, 239); display: inline-block; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;<span class="xv-tag-name" draggable="false" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">response</span>&nbsp;<span class="xv-attr" style="color: rgb(79, 159, 207); position: relative; "><span class="xv-attr-name" style="color: rgb(79, 159, 207); ">length</span>=&quot;<span class="xv-attr-value" style="color: rgb(212, 73, 80); ">0</span>&quot;</span>&gt;</span><span class="xv-tag-children"><span class="xv-node xv-tag xv-one-line" data-xv-id="1" style="padding-top: 0.25em; padding-right: 0px; padding-bottom: 0.2em; padding-left: 15px; font-family: Consolas, 'DejaVu Sans Mono', monospace; position: relative; display: block; "><span class="xv-tag-open" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;<span class="xv-tag-name" draggable="false" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">error</span>&nbsp;<span class="xv-attr" style="color: rgb(79, 159, 207); position: relative; "><span class="xv-attr-name" draggable="false" style="color: rgb(79, 159, 207); ">code</span>=&quot;<span class="xv-attr-value" style="color: rgb(212, 73, 80); ">auth</span>&quot;</span>&gt;</span><span class="xv-tag-children"><span class="xv-text" data-xv-id="2" style="color: rgb(0, 0, 0); padding-left: 0px; display: inline; ">User cannot be authentificated</span></span><span class="xv-tag-close" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;/<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">error</span>&gt;</span></span></span><span class="xv-tag-close" style="color: rgb(95, 175, 239); display: inline-block; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;/<span class="xv-tag-name" draggable="false" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">response</span>&gt;</span>
		</p>
			                                                     	
		<h2>Available methods</h2>
		<h3>Stock quotes info</h3>
			<h4>URL</h4>
			<span class="api-url">
			<?=$this->context->createUrl(Stock_Router::ACT_WEBSERVICE_QUOTES_INFO)?>&amp;username=&lt;NAME&gt;&amp;password=&lt;PASSWORD&gt;&amp;date=&lt;YYYY-MM-DD&gt;<br/>
			</span>
			<h4>Additional parameters</h4>
			<ul>
				<li><strong><?=Stock_Webservice_Controller::PARAM_SYMBOL?></strong> - if provided only result matched this symbol will be shown</li>
			</ul>
			<h4>Response format</h4>
			<p>
			<span class="xv-tag-open" style="color: rgb(95, 175, 239); display: inline-block; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">response</span>&nbsp;<span class="xv-attr" style="color: rgb(79, 159, 207); position: relative; "><span class="xv-attr-name" style="color: rgb(79, 159, 207); ">length</span>=&quot;<span class="xv-attr-value" style="color: rgb(212, 73, 80); ">2</span>&quot;</span>&gt;</span><span class="xv-tag-children"><span class="xv-node xv-tag xv-one-line" data-xv-id="1" style="padding-top: 0.25em; padding-right: 0px; padding-bottom: 0.2em; padding-left: 15px; font-family: Consolas, 'DejaVu Sans Mono', monospace; position: relative; display: block; "><span class="xv-tag-open" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">symbol</span>&nbsp;<span class="xv-attr" style="color: rgb(79, 159, 207); position: relative; "><span class="xv-attr-name" style="color: rgb(79, 159, 207); ">name</span>=&quot;<span class="xv-attr-value" style="color: rgb(212, 73, 80); ">GE</span>&quot;</span>&nbsp;<span class="xv-attr" style="color: rgb(79, 159, 207); position: relative; "><span class="xv-attr-name" draggable="false" style="color: rgb(79, 159, 207); ">priceClose</span>=&quot;<span class="xv-attr-value" style="color: rgb(212, 73, 80); ">15.35</span>&quot;</span>&nbsp;<span class="xv-attr" style="color: rgb(79, 159, 207); position: relative; "><span class="xv-attr-name" style="color: rgb(79, 159, 207); ">volume</span>=&quot;<span class="xv-attr-value" style="color: rgb(212, 73, 80); ">1392840</span>&quot;</span>&nbsp;/&gt;</span></span><span class="xv-node xv-tag xv-one-line" data-xv-id="2" style="padding-top: 0.25em; padding-right: 0px; padding-bottom: 0.2em; padding-left: 15px; font-family: Consolas, 'DejaVu Sans Mono', monospace; position: relative; display: block; "><span class="xv-tag-open" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;<span class="xv-tag-name" draggable="false" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">symbol</span>&nbsp;<span class="xv-attr" style="color: rgb(79, 159, 207); position: relative; "><span class="xv-attr-name" style="color: rgb(79, 159, 207); ">name</span>=&quot;<span class="xv-attr-value" style="color: rgb(212, 73, 80); ">GENZ</span>&quot;</span>&nbsp;<span class="xv-attr" style="color: rgb(79, 159, 207); position: relative; "><span class="xv-attr-name" draggable="false" style="color: rgb(79, 159, 207); ">priceClose</span>=&quot;<span class="xv-attr-value" style="color: rgb(212, 73, 80); ">56.91</span>&quot;</span>&nbsp;<span class="xv-attr" style="color: rgb(79, 159, 207); position: relative; "><span class="xv-attr-name" style="color: rgb(79, 159, 207); ">volume</span>=&quot;<span class="xv-attr-value" style="color: rgb(212, 73, 80); ">24587</span>&quot;</span>&nbsp;/&gt;</span></span></span><span class="xv-tag-close" style="color: rgb(95, 175, 239); display: inline-block; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;/<span class="xv-tag-name" draggable="false" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">response</span>&gt;</span>
			</p>
			<br/>
		<h3>User quotes info</h3>
			<h4>URL</h4>
			<span class="api-url">
			<?=$this->context->createUrl(Stock_Router::ACT_WEBSERVICE_USER_QUOTES)?>&amp;username=&lt;NAME&gt;&amp;password=&lt;PASSWORD&gt;&amp;date=&lt;YYYY-MM-DD&gt;<br/>
			</span>
			<h4>Response format</h4>
			<p>
			<span class="xv-tag-open" style="color: rgb(95, 175, 239); display: inline-block; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">response</span>&nbsp;<span class="xv-attr" style="color: rgb(79, 159, 207); position: relative; "><span class="xv-attr-name" draggable="false" style="color: rgb(79, 159, 207); ">length</span>=&quot;<span class="xv-attr-value" style="color: rgb(212, 73, 80); ">2</span>&quot;</span>&gt;</span><span class="xv-tag-children"><span class="xv-node xv-tag" data-xv-id="1" style="padding-top: 0.25em; padding-right: 0px; padding-bottom: 0.2em; padding-left: 15px; font-family: Consolas, 'DejaVu Sans Mono', monospace; position: relative; display: block; "><span class="xv-tag-open" style="color: rgb(95, 175, 239); display: inline-block; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">symbol</span>&nbsp;<span class="xv-attr" style="color: rgb(79, 159, 207); position: relative; "><span class="xv-attr-name" style="color: rgb(79, 159, 207); ">name</span>=&quot;<span class="xv-attr-value" style="color: rgb(212, 73, 80); ">GOOG</span>&quot;</span>&gt;</span><span class="xv-tag-children"><span class="xv-node xv-tag xv-one-line" data-xv-id="2" style="padding-top: 0.25em; padding-right: 0px; padding-bottom: 0.2em; padding-left: 15px; font-family: Consolas, 'DejaVu Sans Mono', monospace; position: relative; display: block; "><span class="xv-tag-open" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">priceAvg</span>&gt;</span><span class="xv-tag-children"><span class="xv-text" data-xv-id="3" style="color: rgb(0, 0, 0); padding-left: 0px; display: inline; ">481.09</span></span><span class="xv-tag-close" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;/<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">priceAvg</span>&gt;</span></span><span class="xv-node xv-tag xv-one-line" data-xv-id="4" style="padding-top: 0.25em; padding-right: 0px; padding-bottom: 0.2em; padding-left: 15px; font-family: Consolas, 'DejaVu Sans Mono', monospace; position: relative; display: block; "><span class="xv-tag-open" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">quantity</span>&gt;</span><span class="xv-tag-children"><span class="xv-text" data-xv-id="5" style="color: rgb(0, 0, 0); padding-left: 0px; display: inline; ">4</span></span><span class="xv-tag-close" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;/<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">quantity</span>&gt;</span></span><span class="xv-node xv-tag xv-one-line" data-xv-id="6" style="padding-top: 0.25em; padding-right: 0px; padding-bottom: 0.2em; padding-left: 15px; font-family: Consolas, 'DejaVu Sans Mono', monospace; position: relative; display: block; "><span class="xv-tag-open" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">lastPrice</span>&gt;</span><span class="xv-tag-children"><span class="xv-text" data-xv-id="7" style="color: rgb(0, 0, 0); padding-left: 0px; display: inline; ">475.12</span></span><span class="xv-tag-close" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;/<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">lastPrice</span>&gt;</span></span><span class="xv-node xv-tag xv-one-line" data-xv-id="8" style="padding-top: 0.25em; padding-right: 0px; padding-bottom: 0.2em; padding-left: 15px; font-family: Consolas, 'DejaVu Sans Mono', monospace; position: relative; display: block; "><span class="xv-tag-open" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">change</span>&gt;</span><span class="xv-tag-children"><span class="xv-text" data-xv-id="9" style="color: rgb(0, 0, 0); padding-left: 0px; display: inline; ">0.00</span></span><span class="xv-tag-close" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;/<span class="xv-tag-name" draggable="false" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">change</span>&gt;</span></span><span class="xv-node xv-tag xv-one-line" data-xv-id="10" style="padding-top: 0.25em; padding-right: 0px; padding-bottom: 0.2em; padding-left: 15px; font-family: Consolas, 'DejaVu Sans Mono', monospace; position: relative; display: block; "><span class="xv-tag-open" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">mktPrice</span>&gt;</span><span class="xv-tag-children"><span class="xv-text" data-xv-id="11" style="color: rgb(0, 0, 0); padding-left: 0px; display: inline; ">1,900.48</span></span><span class="xv-tag-close" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;/<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">mktPrice</span>&gt;</span></span><span class="xv-node xv-tag xv-one-line" data-xv-id="12" style="padding-top: 0.25em; padding-right: 0px; padding-bottom: 0.2em; padding-left: 15px; font-family: Consolas, 'DejaVu Sans Mono', monospace; position: relative; display: block; "><span class="xv-tag-open" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">profit</span>&gt;</span><span class="xv-tag-children"><span class="xv-text" data-xv-id="13" style="color: rgb(0, 0, 0); padding-left: 0px; display: inline; ">-23.86</span></span><span class="xv-tag-close" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;/<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">profit</span>&gt;</span></span><span class="xv-node xv-tag xv-one-line" data-xv-id="14" style="padding-top: 0.25em; padding-right: 0px; padding-bottom: 0.2em; padding-left: 15px; font-family: Consolas, 'DejaVu Sans Mono', monospace; position: relative; display: block; "><span class="xv-tag-open" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">percent</span>&gt;</span><span class="xv-tag-children"><span class="xv-text" data-xv-id="15" style="color: rgb(0, 0, 0); padding-left: 0px; display: inline; ">1.24</span></span><span class="xv-tag-close" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;/<span class="xv-tag-name" draggable="false" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">percent</span>&gt;</span></span></span><span class="xv-tag-close" style="color: rgb(95, 175, 239); display: inline-block; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;/<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">symbol</span>&gt;</span></span><span class="xv-node xv-tag" data-xv-id="16" style="padding-top: 0.25em; padding-right: 0px; padding-bottom: 0.2em; padding-left: 15px; font-family: Consolas, 'DejaVu Sans Mono', monospace; position: relative; display: block; "><span class="xv-tag-open" style="color: rgb(95, 175, 239); display: inline-block; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">symbol</span>&nbsp;<span class="xv-attr" style="color: rgb(79, 159, 207); position: relative; "><span class="xv-attr-name" style="color: rgb(79, 159, 207); ">name</span>=&quot;<span class="xv-attr-value" style="color: rgb(212, 73, 80); ">MSFT</span>&quot;</span>&gt;</span><span class="xv-tag-children"><span class="xv-node xv-tag xv-one-line" data-xv-id="17" style="padding-top: 0.25em; padding-right: 0px; padding-bottom: 0.2em; padding-left: 15px; font-family: Consolas, 'DejaVu Sans Mono', monospace; position: relative; display: block; "><span class="xv-tag-open" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">priceAvg</span>&gt;</span><span class="xv-tag-children"><span class="xv-text" data-xv-id="18" style="color: rgb(0, 0, 0); padding-left: 0px; display: inline; ">25.30</span></span><span class="xv-tag-close" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;/<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">priceAvg</span>&gt;</span></span><span class="xv-node xv-tag xv-one-line" data-xv-id="19" style="padding-top: 0.25em; padding-right: 0px; padding-bottom: 0.2em; padding-left: 15px; font-family: Consolas, 'DejaVu Sans Mono', monospace; position: relative; display: block; "><span class="xv-tag-open" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">quantity</span>&gt;</span><span class="xv-tag-children"><span class="xv-text" data-xv-id="20" style="color: rgb(0, 0, 0); padding-left: 0px; display: inline; ">5</span></span><span class="xv-tag-close" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;/<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">quantity</span>&gt;</span></span><span class="xv-node xv-tag xv-one-line" data-xv-id="21" style="padding-top: 0.25em; padding-right: 0px; padding-bottom: 0.2em; padding-left: 15px; font-family: Consolas, 'DejaVu Sans Mono', monospace; position: relative; display: block; "><span class="xv-tag-open" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">lastPrice</span>&gt;</span><span class="xv-tag-children"><span class="xv-text" data-xv-id="22" style="color: rgb(0, 0, 0); padding-left: 0px; display: inline; ">25.00</span></span><span class="xv-tag-close" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;/<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">lastPrice</span>&gt;</span></span><span class="xv-node xv-tag xv-one-line" data-xv-id="23" style="padding-top: 0.25em; padding-right: 0px; padding-bottom: 0.2em; padding-left: 15px; font-family: Consolas, 'DejaVu Sans Mono', monospace; position: relative; display: block; "><span class="xv-tag-open" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;<span class="xv-tag-name" draggable="false" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">change</span>&gt;</span><span class="xv-tag-children"><span class="xv-text" data-xv-id="24" style="color: rgb(0, 0, 0); padding-left: 0px; display: inline; ">0.00</span></span><span class="xv-tag-close" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;/<span class="xv-tag-name" draggable="false" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">change</span>&gt;</span></span><span class="xv-node xv-tag xv-one-line" data-xv-id="25" style="padding-top: 0.25em; padding-right: 0px; padding-bottom: 0.2em; padding-left: 15px; font-family: Consolas, 'DejaVu Sans Mono', monospace; position: relative; display: block; "><span class="xv-tag-open" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">mktPrice</span>&gt;</span><span class="xv-tag-children"><span class="xv-text" data-xv-id="26" style="color: rgb(0, 0, 0); padding-left: 0px; display: inline; ">125.00</span></span><span class="xv-tag-close" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;/<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">mktPrice</span>&gt;</span></span><span class="xv-node xv-tag xv-one-line" data-xv-id="27" style="padding-top: 0.25em; padding-right: 0px; padding-bottom: 0.2em; padding-left: 15px; font-family: Consolas, 'DejaVu Sans Mono', monospace; position: relative; display: block; "><span class="xv-tag-open" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">profit</span>&gt;</span><span class="xv-tag-children"><span class="xv-text" data-xv-id="28" style="color: rgb(0, 0, 0); padding-left: 0px; display: inline; ">-1.50</span></span><span class="xv-tag-close" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;/<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">profit</span>&gt;</span></span><span class="xv-node xv-tag xv-one-line" data-xv-id="29" style="padding-top: 0.25em; padding-right: 0px; padding-bottom: 0.2em; padding-left: 15px; font-family: Consolas, 'DejaVu Sans Mono', monospace; position: relative; display: block; "><span class="xv-tag-open" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">percent</span>&gt;</span><span class="xv-tag-children"><span class="xv-text" data-xv-id="30" style="color: rgb(0, 0, 0); padding-left: 0px; display: inline; ">1.19</span></span><span class="xv-tag-close" style="color: rgb(95, 175, 239); display: inline; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;/<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">percent</span>&gt;</span></span></span><span class="xv-tag-close" style="color: rgb(95, 175, 239); display: inline-block; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;/<span class="xv-tag-name" draggable="false" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">symbol</span>&gt;</span></span></span><span class="xv-tag-close" style="color: rgb(95, 175, 239); display: inline-block; padding-top: 0px; padding-right: 3px; padding-bottom: 0px; padding-left: 3px; white-space: nowrap; position: relative; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-top-color: transparent; border-right-color: transparent; border-bottom-color: transparent; border-left-color: transparent; border-top-left-radius: 0.8em 0.8em; border-top-right-radius: 0.8em 0.8em; border-bottom-right-radius: 0.8em 0.8em; border-bottom-left-radius: 0.8em 0.8em; ">&lt;/<span class="xv-tag-name" style="color: rgb(47, 111, 159); background-color: rgb(244, 250, 255); ">response</span>&gt;</span>
			</p>	
		<?
	}
	protected function links() {
		/* @var $context Stock_Page_Register_Context */
		$context = $this->context;
		return array(
			'Login' => $context->createUrl(Stock_Router::ACT_LOGIN_FORM)
		);	
	}
}